/*!
    \file TSlot_generated
    \author Kurt Stege
    Generated by the tool \c hpp_generator at Wed Sep 07 16:45:15 CEST 2005
*/

#ifndef NSigslot_TSlot_generated_hpp_INCLUDEGUARD
#define NSigslot_TSlot_generated_hpp_INCLUDEGUARD

/*
History:

(ks) = Kurt Stege, kurt-stege@online.de

2005-07-27 (ks):    File created.
2005-07-28 (ks):    current version, file still in development.
*/

namespace NSigslot {

template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot0
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (void);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (void) const;
    typedef void (*memberFunctionPointer_static) (void);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) ();
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) ();
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot();
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot();
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver();
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver();
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot1
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot2
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot3
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot4
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot5
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot6
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot7
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot8
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8);
    }
};


// ******************************************************************
// ******************************************************************
// ******************************************************************

/*!
	The template class TSlot<n> is used for two purposes.
	That sounds bad, and it might be useful to create two
	distinct classes to separate these tasks. Alas I don't
	have the right ideas at this moment.
	
	First, there are several "higher level" template classes
	to implement some kind of cables, queues, whatever, that
	get two template parameters, namely a signature and the
	class name of the receiving component that implements
	one or for slots for this signature.
	
	These template classe are encouraged to don't expect
	two template parameters tSignature and tReceiver, but
	only one template class tSlot. That is this template
	and provides both types for the selected signature
	and receiving component class.
	
	This first purpose could be done solely by using
	something like:
	
	template <typename T1, typename T2>
	class TSlot
	{
	    typedef T1 tSignature;
	    typedef T2 tReceiver;
	};
	
	Even std::pair would do this job.

	Second purpose, this template class TSlot<n> provides
	some means to actually call a slot of the receiver.
	Most likely, the implementations of the "higher level"
	templates mentions in the first purpose need something
	of this as well.
	
	\par TSig
	     the signature class to be used. It is supposed
	     to use a class generated by a TSignature<n> template.
	     
	\par TReceiver
	     any arbitrary class, typically a component class that
	     has a slot of the signature \c TSig.
*/
template <typename TemplateParameterSig, typename TemplateParameterReceiver>
class TSlot9
{
    public:

    typedef TemplateParameterSig tSignature;
    typedef TemplateParameterReceiver tReceiver;

    typedef void (TemplateParameterReceiver::*memberFunctionPointer_nonconst) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8, typename tSignature::tType9);
    typedef void (TemplateParameterReceiver::*memberFunctionPointer_const) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8, typename tSignature::tType9) const;
    typedef void (*memberFunctionPointer_static) (typename tSignature::tType1, typename tSignature::tType2, typename tSignature::tType3, typename tSignature::tType4, typename tSignature::tType5, typename tSignature::tType6, typename tSignature::tType7, typename tSignature::tType8, typename tSignature::tType9);

    static void callSlot (const tReceiver &receiver, memberFunctionPointer_const slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }

    static void callSlot (tReceiver &receiver, memberFunctionPointer_nonconst slot, const typename tSignature::CMessage &msg)
    {
        (receiver .* slot) (msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }

    static void callSlot (const tReceiver & /*receiver*/, memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }

    static void callSlot (memberFunctionPointer_static slot, const typename tSignature::CMessage &msg)
    {
        slot(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }

    static void callOperator (const tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }

    static void callOperator (tReceiver &receiver, const typename tSignature::CMessage &msg)
    {
        receiver(msg.m_par1, msg.m_par2, msg.m_par3, msg.m_par4, msg.m_par5, msg.m_par6, msg.m_par7, msg.m_par8, msg.m_par9);
    }
};


} // namespace NSigslot

#endif // NSigslot_TSlot_generated_hpp_INCLUDEGUARD

/*
    end of file generated by the tool \c hpp_generator
*/
